/*
 *  iCalendar Widget
 *  
 *
 *  Created by Thomas Jannaud on 09/03/08.
 *  Copyright 2008 __Jannaud's Technical Company__. All rights reserved.
 *
 */

var growboxInset; // pour le Resize du Widget
var lesid= new Array(); // à une date correspond un id de "résumé"
var nbbefore = 2;
var nbafter = 31;
var evenmts;
var largeurmin = 180;
var hauteurmin = 200;

function load() {
	new AppleInfoButton($('infoButton'), $('front'), "black", "black", showbackside);
	new AppleGlassButton($('doneButton'), getLocalizedString("Retour"), showfrontside);
	$("calspan").innerText = getLocalizedString("calspan");
	$("daysbefore").innerText = getLocalizedString("daysbefore");
	$("daysafter").innerText = getLocalizedString("daysafter");
	fairedraw();
}

function reupdate() {
	ecrire_ToolTip();
	LoadPreferences();
	var montot = $("idcalendar");
	var moncal = $("idcal");
	montot.removeChild(moncal);
	var tata = document.createElement("table");
	tata.setAttribute("class", "calendrier");
	tata.setAttribute("id", "idcal");
	tata.innerHTML = make_table();
	montot.appendChild(tata);
}

function show() { // on refait le calendrier
	reupdate();
	window.resizeTo(largeurmin, hauteurmin);
}

function fairedraw() {
var ctx = $("imagefond").getContext("2d");
/*var grad = ctx.createRadialGradient(100, 100, 140, 190, 130, 30);
grad.addColorStop(.7, "limegreen");
grad.addColorStop(0.3, "chartreuse");
grad.addColorStop(0.0, "lawngreen");*/
var grad = ctx.createLinearGradient(0, 0, 0, 300);
grad.addColorStop(.7, "limegreen");
grad.addColorStop(0.3, "chartreuse");
grad.addColorStop(0.0, "lawngreen");
ctx.fillStyle = grad;
ctx.fillRect(0, 0, 300, 300);
}

function hide() {
	savePreferences();
}

function ecrire_ToolTip() {
	evenmts = ReadEvents();
	var i = 0;
	for(var e in evenmts) {
		lesid[e] = i;
		i = i + 1;
	}
	// on supprime les anciennes bulles
	var mestooltip = $("idtooltip");
	var nbenfants = mestooltip.childNodes.length;
	for(i = 0; i < nbenfants; i++)
		mestooltip.removeFirstChild;

	// écriture des nouvelles bulles
	for(var e in evenmts) {
		var parag = document.createElement("p");
		parag.setAttribute("class", "bulle cache");
		parag.setAttribute("id", "bulle" + lesid[e]);
		var s = evenmts[e].replace("|", "<br/>");
		parag.innerHTML = s;
		mestooltip.appendChild(parag);
	}
}

function make_table() {
	var retour = getLocalizedString('entete') + '<tbody><tr>';
	var todey = new Date(); var d = new Date();
	d.setDate(d.getDate() - nbbefore);
	var a = (d.getDay() == 0) ? 7 : d.getDay(); // 0 : dimanche ; 6 : samedi
	var lig = 0, col = a;
	
	for(var i = 1; i < a; i++)
		retour= retour + '<td></td>';
	
	for(var i = 0; i < (nbbefore + nbafter + 1); i++) {// le corps
		retour += '<td';
		if (egal_dates(d, todey))
			retour += ' id="today" ';
		if (isin(d, evenmts)) {
			var n = lesid[transform_date(d)];
			retour += ' class="hasevent" onmousemove="montrer(' + n + ');" onmouseout="cacher(' + n + ');"';
		}
		retour = retour + '>' + d.getDate() + '</td>';
		d.setDate(d.getDate() + 1);
		col++;
		if ((a + i)% 7 == 0) {retour+='</tr><tr>'; lig++; col = 1;}
	}
	hauteurmin = 90 + 25 * lig;
	hauteur2 = hauteurmin;
 	return (retour + "</tr></tbody>");
}

// Lecture des événements iCal
function ReadEvents() {
	var sortie = widget.system("/usr/bin/osascript ical.scpt", null).outputString;
	var table = sortie.split('|');
	var retour = [];
	for(var i = 0; i < (table.length - 1); i++) { // sortie : a|b|c|d|....|fin|
		if (i % 2 == 1) {
			if (retour[table[i]] == undefined)
				retour[table[i]] = table[i - 1];
			else
				retour[table[i]] += "|" + table[i - 1];
		}
	}
	return retour;
}


// ******************
//      OPTIONS
function daybeforechanged(elem) {
	nbbefore= Number(elem.options[elem.selectedIndex].value);
	savePreferences();
	reupdate();
}

function dayafterchanged(elem) {
	nbafter= Number(elem.options[elem.selectedIndex].value);
	savePreferences();
	reupdate();
}

function LoadPreferences() {
	var result = widget.preferenceForKey("nbavant");
	if (result == undefined) {result = 2; widget.setPreferenceForKey("2", "nbavant");}
	nbbefore=Number(result);
	
	result = widget.preferenceForKey("nbapres");
	if (result == undefined) {result = 15; widget.setPreferenceForKey("15", "nbapres");}
	nbafter=Number(result);
}

function remove() {
	widget.setPreferenceForKey(null, "nbavant");
	widget.setPreferenceForKey(null, "nbapres");
}

function ApplyPreferences() {
	var avant= {0:0, 1:1, 2:2, 5:3, 7:4};
	var apres= {7:0, 15:1, 21:2, 31:3};
	$("firstpopup").options[avant[nbbefore]].selected = true;
	$("secondpopup").options[apres[nbafter]].selected = true;
}

function savePreferences() { 
	if (window.widget) {
		widget.setPreferenceForKey(String(nbbefore), "nbavant");
		widget.setPreferenceForKey(String(nbafter), "nbapres");
	}
}

/* a n'utiliser que s'il y aura plusieurs instances de notre widgets
	var result = widget.preferenceForKey(createKey("nbavant"));
 function createKey(key) {
 if (window.widget)
 key = widget.identifier + "-" + key;
 return key;
 }*/

// Montrer ou pas les bulles résumé
function montrer(n) {
	$("bulle" + n).setAttribute("class", "bulle vu");
}

function cacher(n) {
	$("bulle" + n).setAttribute("class", "bulle cache");
}

// ******************
// Fonctions pourries
function isin(d, table) { // attention : les mois vont de 0 à 11 pour d !!!
	return (table[transform_date(d)] != undefined);
}
function transform_date(d) {
	return f(d.getDate()) + "/" + f(1 + d.getMonth()) + "/" + ff(d.getYear());
}
function f(x) {
	return ((x < 10) ? ("0" + x) : ("" + x));
}
function ff(x) {
	return ((x < 1900) ? ("" + (1900 +x)) : ("" + x));
}

function $(id) {
	return document.getElementById(id);
}

function maxi(a, b) {
return ((a > b) ? a : b);
}

function egal_dates(d, todey) {
	return (d.getDate() == todey.getDate() && d.getMonth() == todey.getMonth() && d.getYear() == todey.getYear());
}
// widget.system("/usr/bin/osascript -e \'tell application \"iTunes\" to pause\'", null); fonctionne !!!

// ******************
// RESIZE du WIDGET
function mouseDown(event) {
	document.addEventListener("mousemove", mouseMove, true);
	document.addEventListener("mouseup", mouseUp, true);
	growboxInset = {x:(window.innerWidth - event.x), y:(window.innerHeight - event.y)};
	event.stopPropagation();
	event.preventDefault();
}

function mouseMove(event) {
	var x = event.x + growboxInset.x;
	var y = event.y + growboxInset.y;
	if (x < largeurmin)
		x = largeurmin;
	if (y < hauteurmin)
		y = hauteurmin;
	window.resizeTo(x,y); 
	event.stopPropagation();
	event.preventDefault();
}

function mouseUp(event) {
	document.removeEventListener("mousemove", mouseMove, true);
	document.removeEventListener("mouseup", mouseUp, true); 
	event.stopPropagation();
	event.preventDefault();
}


// *************************
//     EFFET DE ROTATION
function showbackside(event)
{
	ApplyPreferences();
	var front = $("front");
	var back = $("back");

	hauteur2 = hauteurmin;
	window.resizeTo(window.innerWidth, 165);
	hauteurmin = 165;

	if (window.widget)
		widget.prepareForTransition("ToBack");
	
	front.style.display="none";
	back.style.display="block";
	
	if (window.widget)		
		setTimeout ('widget.performTransition();', 0);
}

function showfrontside(event)
{
	hauteurmin = hauteur2;
	window.resizeTo(largeurmin, hauteurmin);

	var front = $("front");
	var back = $("back");
	
	if (window.widget)
		widget.prepareForTransition("ToFront");
	
	front.style.display="block";
	back.style.display="none";
	
	if (window.widget)
		setTimeout ('widget.performTransition();', 0);

}

// *************************
// String Localisation

function getLocalizedString (key) {
	try {
		var ret = localizedStrings[key];
		if (ret === undefined)
			ret = key;
		return ret;
	} catch (ex) {}
	return key;
}


if (window.widget) {
    widget.onremove = remove;
    widget.onshow = show;
	 widget.onhide = hide;
}
